package webboard;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.TimerTask;

public class DeleteTimeoutetSessions extends TimerTask {
    private final HashMap<String, Session> SESSION_MAP;
    private final HashMap<String, AuthenticatedSession> AUTH_SESSION_MAP;

    public DeleteTimeoutetSessions(HashMap<String, Session> sessionMap, HashMap<String, AuthenticatedSession> authSessionMap){
        this.SESSION_MAP = sessionMap;
        this.AUTH_SESSION_MAP = authSessionMap;
    }

    @Override
    public void run() {
        try{
            task();
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private void task() throws SQLException {
        long currentTime = System.currentTimeMillis();
        long timeoutSession = 120000; //2 Mins
        long timeoutAuthSession = 600000; //10 Mins

        for(Object obj: SESSION_MAP.keySet().toArray()){
            String s = (String) obj;
            Session ses = SESSION_MAP.get(s);
            if(ses.CREATION_TIME < currentTime - timeoutSession)
                SESSION_MAP.remove(s);
        }

        for(Object obj: AUTH_SESSION_MAP.keySet().toArray()){
            String s = (String) obj;
            AuthenticatedSession a = AUTH_SESSION_MAP.get(s);
            if(a.CREATION_TIME < currentTime - timeoutAuthSession)
                AUTH_SESSION_MAP.remove(s);
        }

        SQLConnector connector = new SQLConnector();
        connector.DeleteAllTokenOlderThan(2592000000L);
    }
}
